#include "puncture.h"

#include <stdlib.h>

static int pi[24][32] = {
 { 0 }, /*  1 */
 { 0 },
 { 0 },
 { 0 },
 { 0 },
 { 0 },
 { 1,1,0,0, 1,1,0,0, 1,1,0,0, 1,1,0,0, 1,1,0,0, 1,1,0,0, 1,1,0,0, 1,0,0,0 }, /*  7 */
 { 1,1,0,0, 1,1,0,0, 1,1,0,0, 1,1,0,0, 1,1,0,0, 1,1,0,0, 1,1,0,0, 1,1,0,0 }, /*  8 */
 { 0 },
 { 0 },
 { 0 },
 { 0 },
 { 1,1,1,0, 1,1,1,0, 1,1,1,0, 1,1,0,0, 1,1,1,0, 1,1,0,0, 1,1,1,0, 1,1,0,0 }, /* 13 */
 { 1,1,1,0, 1,1,1,0, 1,1,1,0, 1,1,0,0, 1,1,1,0, 1,1,1,0, 1,1,1,0, 1,1,0,0 }, /* 14 */
};

void unpuncture(int pattern, int *in, int *out)
{
  int i;

  switch (pattern) {
  case 7:
  case 8:
  case 13: /* 1110 1110 1110 1100 1110 1100 1110 1100 */
  case 14: /* 1110 1110 1110 1100 1110 1110 1110 1100 */
    for (i = 0; i < 32; i++) {
      if (pi[pattern-1][i]) {
        *out++ = *in++;
      } else {
        *out++ = -128;
      }
    }
    break;
  case 15: /* 1110 1110 1110 1110 1110 1110 1110 1100 */
    for (i = 0; i < 7; i++) {
      *out++ = *in++;
      *out++ = *in++;
      *out++ = *in++;
      *out++ = -128;
    }
    *out++ = *in++;
    *out++ = *in++;
    *out++ = -128;
    *out++ = -128;
    break;
  case 16: /* 1110 1110 1110 1110 1110 1110 1110 1110 */
    for (i = 0; i < 8; i++) {
      *out++ = *in++;
      *out++ = *in++;
      *out++ = *in++;
      *out++ = -128;
    }
    break;
  default:
    abort();
  }
}
