#include <stdio.h>

// 05 00 f0 07 0f 66 15 02 f4 89 01 3f 02 f4 38 01 3f 06 f2 2c 01 3f 0a f2 23 01 3f 0e ff 00 7a e8

int crc(char *_data, int len, int poly, int crcsize, int init_value)
{
  unsigned char *data = (unsigned char *)_data;
  int i;
  int j;
  int shift = init_value;

  poly >>= 1;

  for (i = 0; i < len; i++) {
    unsigned char d = data[i];
    for (j = 0; j < 8; j++, d<<=1) {
      int b = ((d >> 7) ^ (shift >> (crcsize-1))) & 1;
      shift = ((shift ^ (-b & poly)) << 1) | b;
    }
  }

  return shift & ((1 << crcsize) - 1);
}

int crc2(char *_data, int len, int ipoly, int crcsize, int init_value)
{
  unsigned char *data = (unsigned char *)_data;
  int poly[16] = { 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0 };
  int b[16];
  int bnext[16];
  int i;
  int j;
  int k;
  int ret;

  for (i = 0; i < 16; i++, init_value >>= 1) b[i] = init_value & 1;

  for (i = 0; i < len; i++) {
    int d = data[i];
    for (j = 0; j < 8; j++, d <<= 1) {
      int in = (d >> 7) & 1;
      in ^= b[15];
      bnext[0] = in;
      for (k = 1; k <= 15; k++)
        bnext[k] = (in & poly[k]) ^ b[k-1];
      //bnext[1] = (in & poly[1]) ^ b[0];
      //bnext[2] = (in & poly[2]) ^ b[1];
      for (k = 0; k <= 15; k++)
        b[k] = bnext[k];
    }
  }

  ret = 0;
  for (k = 15; k >= 0; k--) {
    ret <<= 1;
    ret |= b[k];
  }

  return ret;
}

int main(void)
{
  //char data[] = { 0x05, 0x00, 0xf0, 0x07, 0x0f, 0x66, 0x15, 0x02, 0xf4, 0x89, 0x01, 0x3f, 0x02, 0xf4, 0x38, 0x01, 0x3f, 0x06, 0xf2, 0x2c, 0x01, 0x3f, 0x0a, 0xf2, 0x23, 0x01, 0x3f, 0x0e, 0xff, 0x00 };
  char data[] = { 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };

  //int c = crc(data, sizeof(data), (1<<11) | (1<<4), 16, 0xffff);
  int c = crc(data, sizeof(data), 0x11021, 16, 0xffff);
  int c2 = crc2(data, sizeof(data), (1<<11) | (1<<4), 16, 0xffff);
  printf("c %x ~c %x c2 %x ~c2 %x\n", c, ~c, c2, ~c2);
}
